## GstAudioCdSrc GstAudioCdSrc — Base class for Audio CD sources |

## Functions

gboolean | gst_audio_cd_src_add_track ()

## Properties

gchar * | device | Read / Write
GstAudioCdSrcMode | mode | Read / Write
guint | track | Read / Write

## Types and Values

struct | GstAudioCdSrc
struct | GstAudioCdSrcClass
struct | GstAudioCdSrcTrack
enum | GstAudioCdSrcMode

## Object Hierarchy

        GEnum
        ╰── GstAudioCdSrcMode
        GObject
        ╰── GInitiallyUnowned
            ╰── GstObject
                ╰── GstElement
                    ╰── GstBaseSrc
                        ╰── GstPushSrc
                            ╰── GstAudioCdSrc

## Implemented Interfaces

GstAudioCdSrc implements GstURIHandler.

## Includes

    #include <gst/audio/audio.h>

## Description

Provides a base class for CD digital audio (CDDA) sources, which handles things like seeking, querying, discid calculation, tags, and buffer timestamping.

#### Using GstAudioCdSrc-based elements in applications

GstAudioCdSrc registers two GstFormats of its own, namely the "track" format and the "sector" format. Applications will usually only find the "track" format interesting. You can retrieve that GstFormat for use in seek events or queries with gst_format_get_by_nick("track").

In order to query the number of tracks, for example, an application would set the CDDA source element to READY or PAUSED state and then query the the number of tracks via `gst_element_query_duration()` using the track format acquired above. Applications can query the currently playing track in the same way.

Alternatively, applications may retrieve the currently playing track and the total number of tracks from the taglist that will posted on the bus whenever the CD is opened or the currently playing track changes. The taglist will contain GST_TAG_TRACK_NUMBER and GST_TAG_TRACK_COUNT tags.

Applications playing back CD audio using playbin and cdda://n URIs should issue a seek command in track format to change between tracks, rather than setting a new cdda://n+1 URI on playbin (as setting a new URI on playbin involves closing and re-opening the CD device, which is much much slower).

#### Tags and meta-information

CDDA sources will automatically emit a number of tags, details about which can be found in the libgsttag documentation. Those tags are: GST_TAG_CDDA_CDDB_DISCID, GST_TAG_CDDA_CDDB_DISCID_FULL, GST_TAG_CDDA_MUSICBRAINZ_DISCID, GST_TAG_CDDA_MUSICBRAINZ_DISCID_FULL, among others.

#### Tracks and Table of Contents (TOC)

Applications will be informed of the available tracks via a TOC message on the pipeline's GstBus. The GstToc will contain a GstTocEntry for each track, with information about each track. The duration for each track can be retrieved via the GST_TAG_DURATION tag from each entry's tag list, or calculated via `gst_toc_entry_get_start_stop_times()`. The track entries in the TOC will be sorted by track number.

## Functions

### gst_audio_cd_src_add_track ()

    gboolean
    gst_audio_cd_src_add_track (GstAudioCdSrc *src,
                                GstAudioCdSrcTrack *track);

CDDA sources use this function from their start vfunc to announce the available data and audio tracks to the base source class. The caller should allocate `track` on the stack, the base source will do a shallow copy of the structure (and take ownership of the taglist if there is one).

#### Parameters

src | a GstAudioCdSrc |
track | address of GstAudioCdSrcTrack to add |

#### Returns

FALSE on error, otherwise TRUE.

## Types and Values

### struct GstAudioCdSrc

    struct GstAudioCdSrc;

### struct GstAudioCdSrcClass

    struct GstAudioCdSrcClass {
      GstPushSrcClass pushsrc_class;

      /* open/close the CD device */
      gboolean    (*open)               (GstAudioCdSrc *src, const gchar *device);
      void        (*close)              (GstAudioCdSrc *src);

      /* read one sector (LBA) */
      GstBuffer * (*read_sector)        (GstAudioCdSrc *src, gint sector);

    #if 0
      /* return default device or NULL (optional) */
      gchar *     (*get_default_device) (GstAudioCdSrc *src);

      /* return NULL-terminated string array of CD devices, or NULL (optional) */
      /* FIXME 0.11: reconsider for new probing/device discovery API, remove if in doubt */
      gchar **    (*probe_devices)      (GstAudioCdSrc *src);
    #endif
    };

Audio CD source base class.

#### Members

GstPushSrcClass `pushsrc_class`; | the parent class |
`open` () | opening the device |
`close` () | closing the device |
`read_sector` () | reading a sector |
`get_default_device` () | getting the default device |
`probe_devices` () | probing possible devices |

### struct GstAudioCdSrcTrack

    struct GstAudioCdSrcTrack {
      gboolean     is_audio;      /* TRUE if this is an audio track             */
      guint        num;           /* real track number (usually starts from 1)  */
      guint        start;         /* first sector of track (LBA, not LSN!)      */
      guint        end;           /* last sector of track  (LBA, not LSN!)      */
      GstTagList  *tags;          /* NULL or tags for track (e.g. from cd-text) */
    };

CD track abstraction to communicate TOC entries to the base class.

This structure is only for use by sub-classed in connection with `gst_audio_cd_src_add_track()`.

Applications will be informed of the available tracks via a TOC message on the pipeline's GstBus instead.

#### Members

gboolean `is_audio`; | Whether this is an audio track |
guint `num`; | Track number in TOC (usually starts from 1, but not always) |
guint `start`; | The first sector of this track (LBA) |
guint `end`; | The last sector of this track (LBA) |
GstTagList *`tags`; | Track-specific tags (e.g. from cd-text information), or NULL |

### enum GstAudioCdSrcMode

Mode in which the CD audio source operates. Influences timestamping, EOS handling and seeking.

#### Members

GST_AUDIO_CD_SRC_MODE_NORMAL | each single track is a stream |
GST_AUDIO_CD_SRC_MODE_CONTINUOUS | the entire disc is a single stream |

## Property Details

### The `“device”` property

      “device”                   gchar *

CD device location.

Flags: Read / Write

Default value: NULL

### The `“mode”` property

      “mode”                     GstAudioCdSrcMode

Mode.

Flags: Read / Write

Default value: GST_AUDIO_CD_SRC_MODE_NORMAL

### The `“track”` property

      “track”                    guint

Track.

Flags: Read / Write

Allowed values: [1,99]

Default value: 1